package com.astro.bibliotheca.api.worldenough;

import java.util.Map;

public interface WorldEnoughAPI {

    default String getVersion() {
        return "1.0.0";
    }

    SpawnLogic createSpawnLogic();

    SpawnLogic getSpawnLogic(String id);

    Map<String, SpawnLogic> getAllSpawnLogic();
}
