package com.astro.bibliotheca.util;

import mcp.MethodsReturnNonnullByDefault;
import net.minecraft.block.state.IBlockState;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.NetworkManager;
import net.minecraft.network.play.server.SPacketUpdateTileEntity;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.EnumSkyBlock;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public class TileEntityBase extends TileEntity {

    public int getX() {
        return func_174877_v().func_177958_n();
    }

    public int getY() {
        return func_174877_v().func_177956_o();
    }

    public int getZ() {
        return func_174877_v().func_177952_p();
    }

    @Nullable
    @Override
    public SPacketUpdateTileEntity func_189518_D_() {
        NBTTagCompound data = new NBTTagCompound();
        func_189515_b(data);
        return new SPacketUpdateTileEntity(func_174877_v(), 1, data);
    }

    protected void markForFullUpdate() {
        this.markForUpdate();
        this.markForLightUpdate();
        this.func_70296_d();
    }

    @Override
    public NBTTagCompound func_189517_E_() {
        return func_189515_b(new NBTTagCompound());
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, IBlockState oldState, IBlockState newState) {
        return oldState.func_177230_c() != newState.func_177230_c();
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void onDataPacket(NetworkManager networkManager, SPacketUpdateTileEntity s35PacketUpdateTileEntity) {
        func_145839_a(s35PacketUpdateTileEntity.func_148857_g());
        func_145831_w().func_175704_b(func_174877_v(), func_174877_v());
        markForUpdate();
    }

    protected void markForUpdate() {
        this.func_145831_w().func_184138_a(func_174877_v(), func_145831_w().func_180495_p(func_174877_v()), func_145831_w().func_180495_p(func_174877_v()), 3);
    }

    protected void markForLightUpdate() {
        if (this.func_145831_w().field_72995_K)
            this.func_145831_w().func_184138_a(func_174877_v(), func_145831_w().func_180495_p(func_174877_v()), func_145831_w().func_180495_p(func_174877_v()), 3);
        this.func_145831_w().func_180500_c(EnumSkyBlock.BLOCK, func_174877_v());
    }
}
