package com.astro.bibliotheca.api.worldenough;

import net.minecraft.block.state.IBlockState;

import javax.annotation.Nonnull;
import java.util.Collection;

public interface DimensionLogic {
    DimensionLogic addEntry(@Nonnull SpawnEntry entry);

    Collection<SpawnEntry> getEntries();

    DimensionLogic addBlocksToReplace(IBlockState... states);

    SpawnLogic end();

    Collection<? extends IBlockState> getReplaceableBlocks();

    void clearEntries();
    void clearReplaceBlocks();
}
