package com.astro.bibliotheca.pulsar.gui;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;

public class GuiEvent implements GuiContext {
    public Object gui;
    public final Side side;
    public final int id;
    public final BlockPos pos;
    public final World world;
    public final EntityPlayer player;

    public GuiEvent(Side side, int id, BlockPos pos, World world, EntityPlayer player) {
        this.side = side;
        this.id = id;
        this.pos = pos;
        this.world = world;
        this.player = player;
    }

    @Override
    public Side getSide() {
        return side;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public BlockPos getPos() {
        return pos;
    }

    @Override
    public World getWorld() {
        return world;
    }

    @Override
    public EntityPlayer getPlayer() {
        return player;
    }

    public void setGui(Object gui) {
        this.gui = gui;
    }

    public Object getGui() {
        return gui;
    }
}
