package com.astro.bibliotheca.util;

import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;

import java.util.Optional;

public class TileUtils {
    public static <T extends TileEntity> Optional<T> getTileEntity(IBlockAccess world, BlockPos pos, Class<T> tClass) {
        TileEntity tile = world.func_175625_s(pos);
        return tClass.isInstance(tile) ? Optional.of(tClass.cast(tile)) : Optional.empty();
    }
}
