package com.astro.bibliotheca.worldenough.json;

import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;

import javax.annotation.Nullable;

public class JSONUtils {

    @Nullable
    public static IBlockState getState(String s) {
        String blockString = s;
        IBlockState state = null;
        if (s.contains("#")) {
            String[] split = s.split("#");
            blockString = split[0];
            state = deserializeState(Block.func_149684_b(blockString), split[1]);
        } else {
            Block block1 = Block.func_149684_b(blockString);
            if (block1 != null)
                state = block1.func_176223_P();
        }
        return state;
    }

    public static String serializeState(IBlockState state) {
        String string = state.toString();
        string = string.substring(string.indexOf("[") + 1, string.length() - (string.endsWith("]") ? 1 : 0));
        if (string.equals(state.func_177230_c().getRegistryName().toString())) {
            string = "normal";
        }
        return string;
    }

    public static IBlockState deserializeState(Block block, String state) {
        for (IBlockState validState : block.func_176194_O().func_177619_a()) {
            String string = validState.toString();
            string = string.substring(string.indexOf("[") + 1, string.length() - (string.endsWith("]") ? 1 : 0));
            if (string.equals(block.getRegistryName().toString())) {
                string = "";
            }

            if (state.equals(string)) {
                return validState;
            }
        }

        return null;
    }
}
